############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: session_count.py,v 1.2 2000/12/28 17:45:07 bazsi Exp $
##
############################################################################
# Demonstrates how one can implement session counting as long as Zorp
# has no built in feature to do that.
# 

from Zorp.Zorp import init, debug, message, TRUE, FALSE
from Zorp import Zorp
from Zorp.Zone import InetZone
from Zorp.Service import Service
from Zorp.SockAddr import SockAddrInet
from Zorp.Chainer import TransparentChainer, DirectedChainer, InbandChainer
from Zorp.Plug import PlugProxy
from Zorp import Ftp
from Zorp.Ftp import FtpProxyAllow, FtpProxyMinimal
from Zorp.Listener import Listener

Zorp.firewall_name = 'fw@site-net'

InetZone('site-net', '192.168.1.0/24',
         inbound_services=["*"], 
         outbound_services=["*"])

InetZone('local', '127.0.0.0/8',
         inbound_services=["*"],
         outbound_services=["*"])

InetZone('internet', '0.0.0.0/0',
         inbound_services=["*"], 
         outbound_services=["*"])

myftpsessions=0

class MyFtp(FtpProxyMinimal):

	def config(self):
		FtpProxyMinimal.config(self)
		self.transparent_mode = FALSE

	def startUp(self):
		global myftpsessions
		
		myftpsessions = myftpsessions + 1
		if myftpsessions > 2:
			self.destroy()

	def shutDown(self):
		global myftpsessions
		
		myftpsessions = myftpsessions - 1

def zorp():

 	Service("ftp", DirectedChainer(SockAddrInet('127.0.0.1', 21)), MyFtp)
 	Listener(SockAddrInet("0.0.0.0", 2121), "ftp")

