/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: receive.c,v 1.10 2001/01/02 08:01:30 sasa Exp $
 *
 * Author  : Bazsi
 * Auditor : kisza
 * Last version: 1.7
 * Notes:
 *   - comments
 *   - process identifiers in messages
 *
 * Author  : Bazsi
 * Auditor : kisza
 * Last version: 1.7
 * Notes:
 *   - comments
 *   - process identifiers in messages
 *
 ***************************************************************************/

#define FD_ZORP 0
#define FD_PROXY 1

#include <zorp/receive.h>
#include <zorp/sockaddr.h>
#include <zorp/packsock.h>
#include <zorp/log.h>

#include <sys/types.h>
#include <netinet/in.h>
#include <unistd.h>
#include <fcntl.h>

ZIOReceive *
z_io_receive_new(ZSockAddr * local, ZReceiveFunc callback, gpointer user_data)
{
  ZIOReceive *r = g_new(ZIOReceive, 1);
  struct sockaddr_in *sa;

  z_log(NULL, CORE_DEBUG, 7, "z_io_receive_new()");

  r->local = z_sockaddr_ref(local);
  r->callback = callback;
  r->user_data = user_data;
  sa = (struct sockaddr_in *) &local->sa;
  r->port = ntohs(sa->sin_port);

  if (socketpair(AF_UNIX, SOCK_STREAM, 0, r->fd) == -1)
    {
      z_warning(0, "socketpair failed: %m");
      g_free(r);
      return NULL;
    }

  if (!z_packsock_add_default_fd(r->port, r->fd[FD_ZORP]))
    {
      z_warning(0, "error setting default fd of UDP receiver");
      close(r->fd[0]);
      close(r->fd[1]);
      g_free(r);
      return NULL;
    }
  (r->callback) (r->fd[FD_PROXY], r->user_data);
  return r;
}

void
z_io_receive_destroy(ZIOReceive * r)
{
  z_packsock_close(r->port);
  close(r->fd[FD_ZORP]);
  close(r->fd[FD_PROXY]);
  z_sockaddr_unref(r->local);
  g_free(r);
}
