/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: ssl.c,v 1.1.2.1 2001/04/06 14:56:02 bazsi Exp $
 *
 ***************************************************************************/

/* interface between Zorp and the SSL library */

#include <zorp/ssl.h>
#include <zorp/stream.h>

static int ssl_initialized = 0;

void
z_ssl_init()
{
  if (ssl_initialized)
    return;
  SSL_library_init();
  SSL_load_error_strings();

  ssl_initialized = 1;
}

static void
z_stream_shutdown_ssl(ZStream *s, int how)
{
  /*  int res;
  z_fd_set_nonblock(s->fd, FALSE);
  SSL_shutdown(((GIOSSLChannel *) s->channel)->ssl); */
}

void z_stream_ssl(ZStream *self, SSL *ssl)
{
  g_io_channel_unref(self->channel);
  self->channel = g_io_channel_ssl_new(ssl);
  self->shutdown = z_stream_shutdown_ssl;
}
