/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: labelset.h,v 1.3 2000/09/25 12:11:25 bazsi Exp $
 *
 ***************************************************************************/

#ifndef ZORP_LABELSET_H_INCLUDED
#define ZORP_LABELSET_H_INCLUDED

#define Z_LABELSET_MAX_GROUP 16
#define Z_LABELSET_MAX_NHC 16

typedef struct _ZLabelSet
{
  gint refcnt;

  int rmax, wmin;
  int group_ctr;
  char *groups[Z_LABELSET_MAX_GROUP];
  int nhc_ctr;
  char *nhcs[Z_LABELSET_MAX_NHC];
} ZLabelSet;

ZLabelSet *z_label_set_new();
ZLabelSet *z_label_set_ref(ZLabelSet * r);
void z_label_set_unref(ZLabelSet * r);
void z_label_set_add_group(ZLabelSet * r, char *grp);
void z_label_set_add_nhc(ZLabelSet * r, char *nhc);

#endif
