/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: receive.h,v 1.6 2000/08/01 10:10:36 bazsi Exp $
 *
 ***************************************************************************/

#ifndef ZORP_RECEIVE_H_INCLUDED
#define ZORP_RECEIVE_H_INCLUDED

#include <zorp/io.h>
#include <zorp/zorp.h>
#include <zorp/sockaddr.h>

typedef struct _ZUDPPacket
{
  ZSockAddr *from;
  ZSockAddr *to;
  int length;
  char *data;
} ZUDPPacket;

typedef void (*ZReceiveFunc) (int fd, gpointer user_data);

typedef struct _ZIOReceive
{
  ZSockAddr *local;
  ZReceiveFunc callback;
  int port;
  int fd[2];
  gpointer user_data;
} ZIOReceive;


ZIOReceive *z_io_receive_new(ZSockAddr * local,
			     ZReceiveFunc callback, gpointer user_data);
void z_io_receive_destroy(ZIOReceive * r);

#endif
