/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: zpython.h,v 1.15 2000/08/15 13:05:51 bazsi Exp $
 *
 ***************************************************************************/

#ifndef ZORP_ZPYTHON_H_INCLUDED
#define ZORP_ZPYTHON_H_INCLUDED

#include <zorp/zorp.h>
#include <Python.h>

/*+

  ZPolicyObj is a reference counted data structure, capable of holding
  a value in the policy layer. Currently it's just a simple PyObject.

  +*/
typedef PyObject ZPolicyObj;

/*+

  Each C thread needs a Policy thread data structure.

  +*/
typedef PyThreadState ZPolicyThread;

extern PyThreadState *z_python_global_state;

gboolean z_python_init(void);
gboolean z_python_destroy(void);

void z_python_lock(void);
void z_python_unlock(void);


#endif
