/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: anypy.c,v 1.10 2001/01/04 08:21:37 sasa Exp $
 *
 ***************************************************************************/
 
#include <zorp/zorp.h>
#include <zorp/proxy.h>
#include <zorp/thread.h>
#include <zorp/policy.h>
#include <zorp/zpython.h>
#include <zorp/pystream.h>
#include <zorp/registry.h>

typedef struct _ZAnyPyProxy
{
  ZProxy super;
} ZAnyPyProxy;

static void
anypy_thread(gpointer s)
{
  ZAnyPyProxy *self = (ZAnyPyProxy *) s;
  gboolean called;
  
  z_policy_lock(self->super.thread);  
  z_policy_call(self->super.handler, "proxyThread", NULL, &called);
  
  z_policy_unlock(self->super.thread);
  z_proxy_destroy(&self->super);
}

ZProxy *
anypy_proxy_new(gchar *session_id,
		ZorpStream *client, 
                ZPolicyObj *handler)
{
  ZAnyPyProxy *self = g_new0(ZAnyPyProxy, 1);
  
  z_proxy_init(&self->super, session_id, client->stream, handler);
  
  z_thread_new(session_id, anypy_thread, self);
  return &self->super;
}

gint
zorp_module_init(void)
{
  z_registry_add("anypy", ZR_PYPROXY, anypy_proxy_new);
  return TRUE;
}
