/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: ftpcmd.h,v 1.8 2000/12/13 12:24:14 sasa Exp $
 *
 * Author:  Andras Kis-Szabo <kisza@sch.bme.hu>
 * Author:  Attila SZALAY <sasa@balabit.hu>
 * Auditor:
 * Notes:
 *
 ***************************************************************************/


#ifndef __FTP_PARSE_H
#define __FTP_PARSE_H

/* declare ftp command parser functions */

guint ftp_command_parse_noarg  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_path   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_path  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_string (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_ABOR   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_ABOR  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_HELP   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_MODE   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_PASS   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_PASS  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_PASV   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_PASV  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_PORT   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_PORT  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_QUIT   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_QUIT  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_STRU   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_TYPE   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_USER   (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_USER  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_answer_RNFR  (FtpProxy *self, FtpInternalCommand *command);
guint ftp_command_parse_RNTO   (FtpProxy *self, FtpInternalCommand *command);

#if 0
int ftp_command_parse_sftp (FtpProxy * self, char *line, int length, FtpCommandDescriptor * command);
int ftp_command_parse_ALLO (FtpProxy * self, char *line, int length, FtpCommandDescriptor * command);
int ftp_command_parse_ACCT (FtpProxy * self, char *line, int length, FtpCommandDescriptor * command);
int ftp_command_parse_REIN (FtpProxy * self, char *line, int length, FtpCommandDescriptor * command);
int ftp_command_parse_UNKN (FtpProxy * self, char *line, int length, long flag);
#endif

#endif
