############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Sink.py,v 1.4 2001/02/22 13:29:55 bazsi Exp $
##
## Author  : 
## Auditor : 
## Last version: 
## Notes:
##
############################################################################

import Zorp, Service, Connector, Proxy

class SinkProxy(Proxy.DatagramProxy):
	"""Wrapper class for the datagram oriented sink proxy

	Sink is a one-way UDP relay, making it possible to send
	and receive UDP datagrams.
	
	"""

	def __init__(self, session):
		"""Initializes a SinkProxy instance.

		Initializes attributes based on arguments.
			
		Arguments

		  self -- this instance
		  
		  session -- Session we belong to
		"""
		Proxy.DatagramProxy.__init__(self, "sink", session)

	def packet(self, frm, to, length):
		"""Function to process an UDP packet.
		
		This function is called by the proxy module as a hook
		to change packet characteristics. 'from' and 'to'
		is a SockAddrInet instance, and as such has
		'ip' and 'port' attributes which can be changed here.
		
		Arguments
		
		  self -- this instance
		  
		  frm -- packet source address
		  
		  to -- packet destination address
		  
		  length -- packet length
		
		"""
		raise NotImplementedError
